'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _deepEqual = require('deep-equal');

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _magicVirtualElement = require('magic-virtual-element');

var _magicVirtualElement2 = _interopRequireDefault(_magicVirtualElement);

var _imagesloaded = require('imagesloaded');

var _imagesloaded2 = _interopRequireDefault(_imagesloaded);

var _objectOmit = require('object-omit');

var _objectOmit2 = _interopRequireDefault(_objectOmit);

var _packery = require('packery');

var _packery2 = _interopRequireDefault(_packery);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
	children: {
		type: 'array'
	},
	component: {
		type: 'string'
	},
	instance: {
		type: 'function'
	},
	options: {
		type: 'object'
	}
}; /** @jsx dom */


var defaultProps = {
	component: 'div',
	instance: function instance() {}
};

var afterRender = function afterRender(_ref, el) {
	var props = _ref.props;
	var instance = props.instance,
	    options = props.options;


	(0, _imagesloaded2.default)(el, function () {
		var packery = new _packery2.default(el, options);
		var resizeTimer = void 0;

		packery.layout();
		instance(packery);

		window.addEventListener('resize', function () {
			clearTimeout(resizeTimer);
			resizeTimer = setTimeout(function () {
				return packery.layout();
			}, 100);
		});
	});
};

var shouldUpdate = function shouldUpdate(_ref2, nextProps) {
	var props = _ref2.props;
	return !(0, _deepEqual2.default)(props, nextProps);
};

var render = function render(_ref3) {
	var props = _ref3.props;
	var children = props.children,
	    component = props.component;

	return (0, _magicVirtualElement2.default)(component, (0, _objectOmit2.default)(props, Object.keys(propTypes)), children);
};

exports.default = { afterRender: afterRender, defaultProps: defaultProps, propTypes: propTypes, render: render, shouldUpdate: shouldUpdate };
